#!/usr/bin/python
# -*- coding: utf-8 -*-
DefUnitOrderDict = {
    "Die": 0,
    "Stop": 1,
    "Guard (Normal)": 2,
    "Guard (Player)": 3,
    "Guard (Subunit)": 4,
    "Guard (Bunker)": 5,
    "Ignore (Normal)": 6,
    "Stop (Reaver)": 7,
    "Attack": 8,
    "Attack (Obscured)": 9,
    "Attack Unit (Normal)": 10,
    "Attack In Range": 11,
    "Attack Ground (Unused)": 12,
    "Hover (Unused)": 13,
    "Attack Move": 14,
    "Building Is Being Infested": 15,
    "Nothing 1 (Unused)": 16,
    "Power-Up (Unused)": 17,
    "Guard (Building)": 18,
    "Attack (Building)": 19,
    "Script (Spider Mine)": 20,
    "Stay In Range": 21,
    "Attack (Subunit)": 22,
    "Nothing 2 (Normal)": 23,
    "Nothing 3 (Unused)": 24,
    "Drone Start Mutate": 25,
    "Drone Mutate": 26,
    "Cast Spell (Infest 1)": 27,
    "Cast Spell (Infest 2)": 28,
    "Infest (Queen)": 29,
    "Build (SCV)": 30,
    "Build (Probe)": 31,
    "Create Building (Probe)": 32,
    "Is Building (SCV)": 33,
    "Repair Unit (SCV)": 34,
    "Repair Unit (Obscured)": 35,
    "Place Add-On": 36,
    "Build Add-On": 37,
    "Train (Normal)": 38,
    "Rally to Visible Unit": 39,
    "Rally to Ground Tile": 40,
    "Zerg Birth": 41,
    "Unit Morph": 42,
    "Building Morph": 43,
    "Building Is Constructed (Terran)": 44,
    "Zerg Build Self": 45,
    "Build (Nydus Canal Exit)": 46,
    "Enter (Nydus Canal)": 47,
    "Building Is Constructed (Protoss)": 48,
    "Follow": 49,
    "Idle (Carrier)": 50,
    "Move (Carrier&Reaver)": 51,
    "Stop (Carrier)": 52,
    "Attack (Carrier)": 53,
    "Attack Obscured (Carrier)": 54,
    "Ignore 2 (Carrier)": 55,
    "Attack Unit (Carrier)": 56,
    "Hold Position (Carrier)": 57,
    "Idle (Reaver)": 58,
    "Attack (Reaver)": 59,
    "Attack Obscured (Reaver)": 60,
    "Attack Unit (Reaver)": 61,
    "Hold Position (Reaver)": 62,
    "Training (Subunit)": 63,
    "Move&Attack (Interceptor)": 64,
    "Move&Attack (Scarab)": 65,
    "Recharge Shields (Unit)": 66,
    "Recharge Shields (Global)": 67,
    "Shield Battery Is Recharging": 68,
    "Return To Parent (Interceptor)": 69,
    "Land (Drone)": 70,
    "Land (Building)": 71,
    "Lift Off (Building)": 72,
    "Lift Off (Drone)": 73,
    "Is Lifting Off": 74,
    "Is Researching Technology": 75,
    "Is Performing Upgrade": 76,
    "Idle (Larva)": 77,
    "Is Spawning Larva": 78,
    "Move to Harvest": 79,
    "Move to Harvest Obscured": 80,
    "Move to Harvest Gas": 81,
    "Can Enter Gas Mine": 82,
    "Enter/Exit Gas Mine": 83,
    "Return Gas": 84,
    "Move to Harvest Minerals": 85,
    "Can Harvest Minerals": 86,
    "Harvesting Minerals": 87,
    "Harvesting Minerals Interrupted": 88,
    "Harvest 4 (Unknown)": 89,
    "Return Minerals": 90,
    "Harvesting Interrupted - Recharge Shields": 91,
    "Move/Enter Transport": 92,
    "Idle (Transport)": 93,
    "Load Unit (Mobile Transport)": 94,
    "Load Unit (Bunker)": 95,
    "Load Unit (Unknown)": 96,
    "Idle (Power-Up)": 97,
    "Siege Mode": 98,
    "Tank Mode": 99,
    "Watch Target": 100,
    "Script (Starting Creep Growth)": 101,
    "Script (Spread Creep&Spawn Larva)": 102,
    "Script (Stopping Creep Growth)": 103,
    "Guardian Aspect (Unused)": 104,
    "Move and Morph Archon": 105,
    "Completing Archon Summon": 106,
    "Hold Position (Normal)": 107,
    "Hold Position (Queen)": 108,
    "Cloak": 109,
    "Decloak": 110,
    "Unload Unit (Transport)": 111,
    "Move&Unload Unit (Transport)": 112,
    "Cast Spell (Yamato Gun)": 113,
    "Cast Spell On Obscured (Yamato Gun)": 114,
    "Cast Spell (Lockdown)": 115,
    "Burrow": 116,
    "Idle (Burrowed)": 117,
    "Unburrow": 118,
    "Cast Spell (Dark Swarm)": 119,
    "Cast Spell (Parasite)": 120,
    "Cast Spell (Spawn Broodling)": 121,
    "Cast Spell (EMP Shockwave)": 122,
    "Unknown": 123,
    "Idle (Nuclear Silo)": 124,
    "Attack (Nuke)": 125,
    "Move&Paint Nuke Target": 126,
    "Attack Unit (Nuke)": 127,
    "Attack Ground (Nuke)": 128,
    "Nuke Track (Ghost)": 129,
    "Script (Cloak Nearby Units)": 130,
    "Cloak Nearby Units (Freezes the casting unit)": 131,
    "Place Spider Mine": 132,
    "Script (Right-Click Action)": 133,
    "Attack Unit (Infested Terran)": 134,
    "Attack Ground (Infested Terran)": 135,
    "Hold Position (Suicide Units)": 136,
    "Cast Spell (Recall)": 137,
    "Teleport To Location (Freezes the casting unit)": 138,
    "Cast Spell (Scanner Sweep)": 139,
    "Idle (Scanner Sweep)": 140,
    "Cast Spell (Defensive Matrix)": 141,
    "Cast Spell (Psionic Storm)": 142,
    "Cast Spell (Irradiate)": 143,
    "Cast Spell (Plague)": 144,
    "Cast Spell (Consume)": 145,
    "Cast Spell (Ensnare)": 146,
    "Cast Spell (Stasis Field)": 147,
    "Cast Spell (Hallucination)": 148,
    "Script (Hallucination)": 149,
    "Reset Collision (2 Units)": 150,
    "Reset Collision (Harvester&Mine)": 151,
    "Patrol (Normal)": 152,
    "CTF COP (Initialize)": 153,
    "Idle (CTF COP)": 154,
    "Unknown CTF COP 2": 155,
    "Script (Computer)": 156,
    "Attack Move (Computer)": 157,
    "Move (Harass)": 158,
    "Patrol (Computer)": 159,
    "Guard (Computer)": 160,
    "Idle (Rescuable)": 161,
    "Idle (Neutral)": 162,
    "Return To Base (Computer)": 163,
    "Script (PSI Provider)": 164,
    "Fatal (Scarab)": 165,
    "Idle (Critter)": 166,
    "Idle (Trap)": 167,
    "Open Door": 168,
    "Close Door": 169,
    "Stop (Trap)": 170,
    "Attack (Trap)": 171,
    "Enable Doodad": 172,
    "Disable Doodad": 173,
    "Warp In (Unused)": 174,
    "Idle (Medic)": 175,
    "Cast Spell (Heal)": 176,
    "Move (Medic)": 177,
    "Hold Position&Heal (Medic)": 178,
    "Return To Idle After Heal": 179,
    "Cast Spell (Restoration)": 180,
    "Cast Spell (Disruption Web)": 181,
    "Cast Spell (Mind Control)": 182,
    "Dark Archon Meld": 183,
    "Cast Spell (Feedback)": 184,
    "Cast Spell (Optical Flare)": 185,
    "Cast Spell (Maelstrom)": 186,
    "Move (Junk Yard Dog)": 187,
    "Fatal": 188,
}
